//+------------------------------------------------------------------+
//|                                                          TSI.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Kamil Gazizullin"
#property link      "forexman77@yandex.ru"
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  Blue
#property indicator_level1 -25           //   #0   
#property indicator_level2 25            //   #1   
#property indicator_level3 0   
#property strict        
//--- input parameters
extern int       Period_=14;
extern int       p2 =7;
extern int       p3 =5;
extern int       p4 =3;
//--- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];
double ExtMapBuffer9[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(9);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexBuffer(5,ExtMapBuffer6);
   SetIndexBuffer(6,ExtMapBuffer7);
   SetIndexBuffer(7,ExtMapBuffer8);
   SetIndexBuffer(8,ExtMapBuffer9); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted(),
   i,limit1;
   limit1=Bars-counted_bars-1;
 
   for(i=limit1;i>=0;i--) 
   {
   ExtMapBuffer2[i]=Close[i]-Close[i+Period_];
   ExtMapBuffer3[i]=MathAbs(Close[i]-Close[i+Period_]);
   }
   for(i=limit1;i>=0;i--) 
   {
   ExtMapBuffer4[i]=iMAOnArray(ExtMapBuffer2,0,p2,0, MODE_EMA,i);
   ExtMapBuffer5[i]=iMAOnArray(ExtMapBuffer3,0,p2,0, MODE_EMA,i);
   }
   for(i=limit1;i>=0;i--)
   { 
   ExtMapBuffer6[i]=iMAOnArray(ExtMapBuffer4,0,p3,0, MODE_EMA,i);
   ExtMapBuffer7[i]=iMAOnArray(ExtMapBuffer5,0,p3,0, MODE_EMA,i);
   }
   for(i=limit1;i>=0;i--) 
   {
   ExtMapBuffer8[i]=iMAOnArray(ExtMapBuffer6,0,p4,0, MODE_EMA,i);
   ExtMapBuffer9[i]=iMAOnArray(ExtMapBuffer7,0,p4,0, MODE_EMA,i);
   }
   for(i=limit1;i>=0;i--){if (ExtMapBuffer9[i]!=0)ExtMapBuffer1[i]=100.0*ExtMapBuffer8[i]/ExtMapBuffer9[i];} 
   return(0);
  }
//+------------------------------------------------------------------+
